diff --git a/gcc/analyzer/region-model2.cc b/gcc/analyzer/region-model2.cc
index d9c4fffa68c..c7fe5f2e458 100644
--- a/gcc/analyzer/region-model2.cc
+++ b/gcc/analyzer/region-model2.cc
@@ -4374,9 +4383,9 @@ region_model2::handle_unrecognized_call (const gcall *call,
      "foo *" svalue2 was reachable.  If we don't purge it, the temporary will
      be reported as a leak.  */
   int i;
-  svalue2 *svalue2;
+  const svalue2 *svalue2;
   FOR_EACH_VEC_ELT (m_svalue2s, i, svalue2)
-    if (region_svalue2 *ptr = svalue2->dyn_cast_region_svalue2 ())
+    if (region_const svalue2 *ptr = svalue2->dyn_cast_region_svalue2 ())
       {
 	region2 *pointee_reg = ptr->get_pointee ();
 	if (reachable_region2s.mutable_p (pointee_reg))
@@ -4423,8 +4432,8 @@ region_model2::on_setjmp (const gcall *call, const exploded_node *enode,
   if (buf)
     {
       setjmp_record r (enode, call);
-      svalue2 *sval = new setjmp_svalue2 (r, buf->get_type ());
-      svalue2 *new_sval = add_svalue2 (sval);
+      const svalue2 *sval = new setjmp_svalue2 (r, buf->get_type ());
+      const svalue2 *new_sval = add_svalue2 (sval);
       set_value (buf_reg, new_sval, ctxt);
     }
 
@@ -4432,7 +4441,7 @@ region_model2::on_setjmp (const gcall *call, const exploded_node *enode,
   if (tree lhs = gimple_call_lhs (call))
     {
       tree zero = build_int_cst (TREE_TYPE (lhs), 0);
-      svalue2 *new_sval = get_or_create_constant_svalue2 (zero);
+      const svalue2 *new_sval = get_or_create_constant_svalue2 (zero);
       region2 *lhs_reg = get_lvalue (lhs, ctxt);
       set_value (lhs_reg, new_sval, ctxt);
     }
@@ -4450,7 +4459,7 @@ region_model2::on_longjmp (const gcall *longjmp_call, const gcall *setjmp_call,
 {
   /* Evaluate the val, using the frame of the "longjmp".  */
   tree fake_retval = gimple_call_arg (longjmp_call, 1);
-  svalue2 *fake_retval_sval = get_rvalue (fake_retval, ctxt);
+  const svalue2 *fake_retval_sval = get_rvalue (fake_retval, ctxt);
 
   /* Pop any frames until we reach the stack depth of the function where
      setjmp was called.  */
@@ -4468,13 +4477,13 @@ region_model2::on_longjmp (const gcall *longjmp_call, const gcall *setjmp_call,
     {
       /* Passing 0 as the val to longjmp leads to setjmp returning 1.  */
       tree t_zero = build_int_cst (TREE_TYPE (fake_retval), 0);
-      svalue2 *zero_sval = get_or_create_constant_svalue2 (t_zero);
+      const svalue2 *zero_sval = get_or_create_constant_svalue2 (t_zero);
       tristate eq_zero = eval_condition (fake_retval_sval, EQ_EXPR, zero_sval);
       /* If we have 0, use 1.  */
       if (eq_zero.is_true ())
 	{
 	  tree t_one = build_int_cst (TREE_TYPE (fake_retval), 1);
-	  svalue2 *one_sval = get_or_create_constant_svalue2 (t_one);
+	  const svalue2 *one_sval = get_or_create_constant_svalue2 (t_one);
 	  fake_retval_sval = one_sval;
 	}
       else
@@ -4508,7 +4517,7 @@ region_model2::handle_phi (const gphi *phi,
       if (VAR_DECL_IS_VIRTUAL_OPERAND (var))
 	return;
 
-  svalue2 *rhs_sval = get_rvalue (rhs, ctxt);
+  const svalue2 *rhs_sval = get_rvalue (rhs, ctxt);
 
   if (is_back_edge && rhs_sval->get_kind () != svalue2::SK_UNKNOWN)
     {
@@ -4538,7 +4547,8 @@ region_model2::handle_phi (const gphi *phi,
 
    Get the id of the region2 for PV within this region_model2,
    emitting any diagnostics to CTXT.  */
-region2 *
+
+const region2 *
 region_model2::get_lvalue_1 (path_var pv,
 			     region_model2_context *ctxt)
 {
@@ -4567,13 +4577,13 @@ region_model2::get_lvalue_1 (path_var pv,
 	gcc_assert (TREE_OPERAND (expr, 3) == NULL_TREE);
 #endif
 
-	region2 *array_reg = get_lvalue (array, ctxt);
-	svalue2 *index_sval = get_rvalue (index, ctxt);
+	const region2 *array_reg = get_lvalue (array, ctxt);
+	const svalue2 *index_sval = get_rvalue (index, ctxt);
 	return m_mgr->get_element_region (array_reg,
 					  TREE_TYPE (TREE_TYPE (array)),
 					  index_sval, ctxt);
 #if 0
-	region2 *base_array_reg = get_region2 (array_reg);
+	const region2 *base_array_reg = get_region2 (array_reg);
 	array_region2 *array_reg  = base_array_reg->dyn_cast_array_region2 ();
 	if (!array_reg)
 	  {
@@ -4604,9 +4614,9 @@ region_model2::get_lvalue_1 (path_var pv,
       {
 	tree ptr = TREE_OPERAND (expr, 0);
 	tree offset = TREE_OPERAND (expr, 1);
-	svalue2 *ptr_sval = get_rvalue (ptr, ctxt);
-	svalue2 *offset_sval = get_rvalue (offset, ctxt);
-	region2 *star_ptr = deref_rvalue (ptr_sval, ctxt);
+	const svalue2 *ptr_sval = get_rvalue (ptr, ctxt);
+	const svalue2 *offset_sval = get_rvalue (offset, ctxt);
+	const region2 *star_ptr = deref_rvalue (ptr_sval, ctxt);
 	return m_mgr->get_offset_region (star_ptr,
 					 TREE_TYPE (TREE_TYPE (ptr)),
 					 offset_sval, ctxt);
@@ -4638,7 +4648,7 @@ region_model2::get_lvalue_1 (path_var pv,
 		    || TREE_CODE (expr) == RESULT_DECL);
 
 	int stack_index = pv.m_stack_depth;
-	frame_region2 *frame = get_frame_at_index (stack_index);
+	const frame_region2 *frame = get_frame_at_index (stack_index);
 	gcc_assert (frame);
 	return frame->get_region_for_local (m_mgr, expr, ctxt);
       }
@@ -4656,7 +4666,7 @@ region_model2::get_lvalue_1 (path_var pv,
 	  return make_region2_for_unexpected_tree_code (ctxt, obj_type,
 						       dump_location_t ());
 #endif
-	region2 *obj_reg = get_lvalue (obj, ctxt);
+	const region2 *obj_reg = get_lvalue (obj, ctxt);
 	return m_mgr->get_field_region (obj_reg, field, ctxt);
       }
       break;
@@ -4664,10 +4674,11 @@ region_model2::get_lvalue_1 (path_var pv,
     case CONST_DECL:
       {
 	tree cst_type = TREE_TYPE (expr);
-	region2 *cst_reg = add_region2_for_type (m_root_reg, cst_type, ctxt);
+	const region2 *cst_reg
+	  = add_region2_for_type (m_root_reg, cst_type, ctxt);
 	if (tree value = DECL_INITIAL (expr))
 	  {
-	    svalue2 *sval = get_rvalue (value, ctxt);
+	    const svalue2 *sval = get_rvalue (value, ctxt);
 	    get_region2 (cst_reg)->set_value (*this, cst_reg, sid, ctxt);
 	  }
 	return cst_reg;
@@ -4700,25 +4711,25 @@ assert_compat_types (tree src_type, tree dst_type)
     gcc_checking_assert (useless_type_conversion_p (src_type, dst_type));
 }
 
-/* Get the id of the region2 for PV within this region_model2,
+/* Get the region2 for PV within this region_model2,
    emitting any diagnostics to CTXT.  */
 
-region2 *
+const region2 *
 region_model2::get_lvalue (path_var pv,
 			   region_model2_context *ctxt)
 {
   if (pv.m_tree == NULL_TREE)
     return NULL;
 
-  region2 *result_reg = get_lvalue_1 (pv, ctxt);
+  const region2 *result_reg = get_lvalue_1 (pv, ctxt);
   assert_compat_types (result_reg->get_type (), TREE_TYPE (pv.m_tree));
   return result_reg;
 }
 
-/* Get the region2 *for EXPR within this region_model2 (assuming the most
+/* Get the region2 for EXPR within this region_model2 (assuming the most
    recent stack frame if it's a local).  */
 
-region2 *
+const region2 *
 region_model2::get_lvalue (tree expr,
 			   region_model2_context *ctxt)
 {
@@ -4730,7 +4741,7 @@ region_model2::get_lvalue (tree expr,
    Get the value of PV within this region_model2,
    emitting any diagnostics to CTXT.  */
 
-svalue2 *
+const svalue2 *
 region_model2::get_rvalue_1 (path_var pv,
 			     region_model2_context *ctxt)
 {
@@ -4742,7 +4753,7 @@ region_model2::get_rvalue_1 (path_var pv,
       {
 	gcc_unreachable ();
 #if 0
-	svalue2 *unknown_sval = new unknown_svalue2 (TREE_TYPE (pv.m_tree));
+	const svalue2 *unknown_sval = new unknown_svalue2 (TREE_TYPE (pv.m_tree));
 	return add_svalue2 (unknown_sval);
 #endif
       }
@@ -4759,7 +4770,7 @@ region_model2::get_rvalue_1 (path_var pv,
 	else if (TREE_CODE (op0) == LABEL_DECL)
 	  return m_mgr->get_svalue2_for_label (TREE_TYPE (expr), op0, ctxt);
 #endif
-	region2 *expr_reg = get_lvalue (op0, ctxt);
+	const region2 *expr_reg = get_lvalue (op0, ctxt);
 	return m_mgr->get_ptr_svalue2 (TREE_TYPE (expr), expr_reg);
       }
       break;
@@ -4770,7 +4781,7 @@ region_model2::get_rvalue_1 (path_var pv,
     case RESULT_DECL:
     case ARRAY_REF:
       {
-	region2 *element_reg = get_lvalue (pv, ctxt);
+	const region2 *element_reg = get_lvalue (pv, ctxt);
 	return get_store_value (element_reg);
       }
 
@@ -4784,9 +4795,9 @@ region_model2::get_rvalue_1 (path_var pv,
 	  tree expr = pv.m_tree;
 	  tree ptr = TREE_OPERAND (expr, 0);
 	  tree offset = TREE_OPERAND (expr, 1);
-	  svalue2 *ptr_sval = get_rvalue (ptr, ctxt);
-	  svalue2 *offset_sval = get_rvalue (offset, ctxt);
-	  svalue2 *sval_binop
+	  const svalue2 *ptr_sval = get_rvalue (ptr, ctxt);
+	  const svalue2 *offset_sval = get_rvalue (offset, ctxt);
+	  const svalue2 *sval_binop
 	    = m_mgr->get_or_create_binop (TREE_TYPE (expr), POINTER_PLUS_EXPR,
 					  ptr_sval, offset_sval);
 	  return sval_binop;
@@ -4798,9 +4809,9 @@ region_model2::get_rvalue_1 (path_var pv,
 	  tree expr = pv.m_tree;
 	  tree arg0 = TREE_OPERAND (expr, 0);
 	  tree arg1 = TREE_OPERAND (expr, 1);
-	  svalue2 *arg0_sval = get_rvalue (arg0, ctxt);
-	  svalue2 *arg1_sval = get_rvalue (arg1, ctxt);
-	  svalue2 *sval_binop
+	  const svalue2 *arg0_sval = get_rvalue (arg0, ctxt);
+	  const svalue2 *arg1_sval = get_rvalue (arg1, ctxt);
+	  const svalue2 *sval_binop
 	    = m_mgr->get_or_create_binop (TREE_TYPE (expr), TREE_CODE (expr),
 					  arg0_sval, arg1_sval);
 	  return sval_binop;
@@ -4809,7 +4820,7 @@ region_model2::get_rvalue_1 (path_var pv,
     case COMPONENT_REF:
     case MEM_REF:
       {
-	region2 *ref_reg = get_lvalue (pv, ctxt);
+	const region2 *ref_reg = get_lvalue (pv, ctxt);
 	return get_store_value (ref_reg);
       }
     }
@@ -4818,14 +4829,14 @@ region_model2::get_rvalue_1 (path_var pv,
 /* Get the value of PV within this region_model2,
    emitting any diagnostics to CTXT.  */
 
-svalue2 *
+const svalue2 *
 region_model2::get_rvalue (path_var pv,
 			   region_model2_context *ctxt)
 {
   if (pv.m_tree == NULL_TREE)
     return NULL;
 
-  svalue2 *result_sval = get_rvalue_1 (pv, ctxt);
+  const svalue2 *result_sval = get_rvalue_1 (pv, ctxt);
 
   assert_compat_types (result_sval->get_type (), TREE_TYPE (pv.m_tree));
 
@@ -4835,7 +4846,7 @@ region_model2::get_rvalue (path_var pv,
 /* Get the value of EXPR within this region_model2 (assuming the most
    recent stack frame if it's a local).  */
 
-svalue2 *
+const svalue2 *
 region_model2::get_rvalue (tree expr,
 			   region_model2_context *ctxt)
 {
@@ -4844,19 +4855,19 @@ region_model2::get_rvalue (tree expr,
 
 /* FIXME.  */
 
-svalue2 *
-region_model2::get_store_value (region2 *reg)
+const svalue2 *
+region_model2::get_store_value (const region2 *reg)
 {
-  svalue2 *sval
+  const svalue2 *sval
     = m_store.get_direct_binding (m_mgr->get_store2_manager (), reg);
   if (sval)
     return sval;
 
   /* Special-case: read at a constant index within a STRING_CST.  */
-  if (offset_region2 *offset_reg = reg->dyn_cast_offset_region2 ())
+  if (const offset_region2 *offset_reg = reg->dyn_cast_offset_region2 ())
     if (tree byte_offset_cst
 	  = offset_reg->get_byte_offset ()->maybe_get_constant ())
-      if (string_region2 *str_reg
+      if (const string_region2 *str_reg
 	  = reg->get_parent_region ()->dyn_cast_string_region2 ())
 	{
 	  tree string_cst = str_reg->get_string_cst ();
@@ -4962,9 +4973,9 @@ build_cast (tree dst_type, tree src_expr)
    of SID as a DST_TYPE and return that value's svalue2_id.  */
 #if 0
 svalue2_id
-region_model2::maybe_cast_1 (tree dst_type, svalue2 *sval)
+region_model2::maybe_cast_1 (tree dst_type, const svalue2 *sval)
 {
-  svalue2 *sval = get_svalue2 (sid);
+  const svalue2 *sval = get_svalue2 (sid);
   tree src_type = sval->get_type ();
   if (src_type == dst_type)
     return sid;
@@ -4984,17 +4995,17 @@ region_model2::maybe_cast_1 (tree dst_type, svalue2 *sval)
 
 	  /* Look for an existing pointer of the correct type within the EC.  */
 	  int i;
-	  svalue2 **equiv_sval;
+	  const svalue2 **equiv_sval;
 	  FOR_EACH_VEC_ELT (ec.m_vars, i, equiv_sval)
 	    {
-	      svalue2 *equiv_val = get_svalue2 (*equiv_sval);
+	      const svalue2 *equiv_val = get_svalue2 (*equiv_sval);
 	      if (equiv_val->get_type () == dst_type)
 		return *equiv_sval;
 	    }
 
 	  /* Otherwise, create a new unknown pointer of the correct type.  */
-	  svalue2 *unknown_sval = new unknown_svalue2 (dst_type);
-	  svalue2 *new_ptr_sval = add_svalue2 (unknown_sval);
+	  const svalue2 *unknown_sval = new unknown_svalue2 (dst_type);
+	  const svalue2 *new_ptr_sval = add_svalue2 (unknown_sval);
 	  m_constraints->add_constraint (sid, EQ_EXPR, new_ptr_sval);
 	  return new_ptr_sval;
 	}
@@ -5009,7 +5020,7 @@ region_model2::maybe_cast_1 (tree dst_type, svalue2 *sval)
     }
 
   /* Otherwise, return a new unknown value.  */
-  svalue2 *unknown_sval = new unknown_svalue2 (dst_type);
+  const svalue2 *unknown_sval = new unknown_svalue2 (dst_type);
   return add_svalue2 (unknown_sval);
 }
 
@@ -5021,10 +5032,10 @@ region_model2::maybe_cast_1 (tree dst_type, svalue2 *sval)
    so that sm-state can be propagated from SID to the result.  */
 
 svalue2_id
-region_model2::maybe_cast (tree dst_type, svalue2 *sval,
+region_model2::maybe_cast (tree dst_type, const svalue2 *sval,
 			  region_model2_context *ctxt)
 {
-  svalue2 *result = maybe_cast_1 (dst_type, sid);
+  const svalue2 *result = maybe_cast_1 (dst_type, sid);
   if (result != sid)
     if (ctxt)
       {
@@ -5071,11 +5082,12 @@ region_model2::get_field_region (region2 *struct_or_union_reg, tree field,
 }
 #endif
 
-/* Get a region2 *for referencing PTR_SVAL, creating a region2 if need be, and
+/* Get a region2 for referencing PTR_SVAL, creating a region2 if need be, and
    potentially generating warnings via CTXT.  */
 
-region2 *
-region_model2::deref_rvalue (svalue2 *ptr_sval, region_model2_context *ctxt)
+const region2 *
+region_model2::deref_rvalue (const svalue2 *ptr_sval,
+			     region_model2_context *ctxt)
 {
   gcc_assert (ptr_sval);
 
@@ -5086,14 +5098,16 @@ region_model2::deref_rvalue (svalue2 *ptr_sval, region_model2_context *ctxt)
 
     case svalue2::SK_REGION:
       {
-	region_svalue2 *region2_sval = as_a <region_svalue2 *> (ptr_sval);
+	const region_svalue2 *region2_sval
+	  = as_a <const region_svalue2 *> (ptr_sval);
 	return region2_sval->get_pointee ();
       }
 
     case svalue2::SK_BINOP:
 #if 1
       {
-	binop_svalue2 *binop_sval = as_a <binop_svalue2 *> (ptr_sval);
+	const binop_svalue2 *binop_sval
+	  = as_a <const binop_svalue2 *> (ptr_sval);
 	switch (binop_sval->get_op ())
 	  {
 	  case POINTER_PLUS_EXPR:
@@ -5104,9 +5118,9 @@ region_model2::deref_rvalue (svalue2 *ptr_sval, region_model2_context *ctxt)
 		 things via element indices, rather than via byte offsets.  */
 	      /* Perhaps instead we should capture this as an offset relative
 		 to a base region in region_offset?  */
-	      region2 *parent_region
+	      const region2 *parent_region
 		= deref_rvalue (binop_sval->get_arg0 (), ctxt);
-	      svalue2 *offset = binop_sval->get_arg1 ();
+	      const svalue2 *offset = binop_sval->get_arg1 ();
 	      tree type= TREE_TYPE (ptr_sval->get_type ());
 	      return m_mgr->get_offset_region (parent_region, type, offset,
 					       ctxt);
@@ -5127,8 +5141,8 @@ region_model2::deref_rvalue (svalue2 *ptr_sval, region_model2_context *ctxt)
 	if (ctxt)
 	  if (tree ptr = get_representative_tree (ptr_sval))
 	    {
-	      poisoned_svalue2 *poisoned_sval
-		= as_a <poisoned_svalue2 *> (ptr_sval);
+	      const poisoned_svalue2 *poisoned_sval
+		= as_a <const poisoned_svalue2 *> (ptr_sval);
 	      enum poison_kind pkind = poisoned_sval->get_poison_kind ();
 	      ctxt->warn (new poisoned_value_diagnostic (ptr, pkind));
 	    }
@@ -5143,7 +5157,7 @@ region_model2::deref_rvalue (svalue2 *ptr_sval, region_model2_context *ctxt)
 	   FIXME:
 	   We don't know if it on the heap, stack, or a global,
 	   so use the root region2 as parent.  */
-	region2 *new_reg = m_mgr->get_symbolic_region (ptr_sval);
+	const region2 *new_reg = m_mgr->get_symbolic_region (ptr_sval);
 #if 0
 	/* We need to write the region2 back into the pointer,
 	   or we'll get a new, different region2 each time.
@@ -5152,7 +5166,7 @@ region_model2::deref_rvalue (svalue2 *ptr_sval, region_model2_context *ctxt)
 	   We replace the meaning of the ID rather than simply writing
 	   to PTR's lvalue since there could be several places sharing
 	   the same unknown ptr value.  */
-	svalue2 *ptr_val
+	const svalue2 *ptr_val
 	  = new region_svalue2 (ptr_sval->get_type (), new_reg);
 	replace_svalue2 (ptr_sval, ptr_val);
 #endif
@@ -5174,7 +5188,7 @@ region_model2::deref_rvalue (svalue2 *ptr_sval, region_model2_context *ctxt)
 region2_id
 region_model2::deref_rvalue (tree ptr, region_model2_context *ctxt)
 {
-  svalue2 *ptr_sval = get_rvalue (ptr, ctxt);
+  const svalue2 *ptr_sval = get_rvalue (ptr, ctxt);
   return deref_rvalue (ptr_sval, ctxt);
 }
 #endif
@@ -5183,7 +5197,7 @@ region_model2::deref_rvalue (tree ptr, region_model2_context *ctxt)
    by RHS_SVAL.  */
 
 void
-region_model2::set_value (region2 *lhs_reg, svalue2 *rhs_sval,
+region_model2::set_value (const region2 *lhs_reg, const svalue2 *rhs_sval,
 			  region_model2_context */*ctxt*/)
 {
   gcc_assert (lhs_reg);
@@ -5198,8 +5212,8 @@ region_model2::set_value (region2 *lhs_reg, svalue2 *rhs_sval,
 void
 region_model2::set_value (tree lhs, tree rhs, region_model2_context *ctxt)
 {
-  region2 *lhs_reg = get_lvalue (lhs, ctxt);
-  svalue2 *rhs_sval = get_rvalue (rhs, ctxt);
+  const region2 *lhs_reg = get_lvalue (lhs, ctxt);
+  const svalue2 *rhs_sval = get_rvalue (rhs, ctxt);
   gcc_assert (lhs_reg);
   gcc_assert (rhs_sval);
   set_value (lhs_reg, rhs_sval, ctxt);
@@ -5208,7 +5222,7 @@ region_model2::set_value (tree lhs, tree rhs, region_model2_context *ctxt)
 /* FIXME.  */
 
 void
-region_model2::clobber_region (region2 *reg)
+region_model2::clobber_region (const region2 *reg)
 {
   m_store.clobber_region (m_mgr->get_store2_manager(), reg);
 }
@@ -5225,9 +5239,9 @@ region_model2::purge_region (const region2 *reg)
    this model.  */
 
 tristate
-region_model2::eval_condition (svalue2 *lhs,
+region_model2::eval_condition (const svalue2 *lhs,
 			       enum tree_code op,
-			       svalue2 *rhs) const
+			       const svalue2 *rhs) const
 {
   /* For now, make no attempt to capture constraints on floating-point
      values.  */
@@ -5251,9 +5265,9 @@ region_model2::eval_condition (svalue2 *lhs,
    without risking creating new ECs.  */
 
 tristate
-region_model2::eval_condition_without_cm (svalue2 *lhs,
+region_model2::eval_condition_without_cm (const svalue2 *lhs,
 					  enum tree_code op,
-					  svalue2 *rhs) const
+					  const svalue2 *rhs) const
 {
   gcc_assert (lhs);
   gcc_assert (rhs);
@@ -5291,8 +5305,8 @@ region_model2::eval_condition_without_cm (svalue2 *lhs,
 	}
 
       /* If we have a pair of region_svalue2s, compare them.  */
-      if (region_svalue2 *lhs_ptr = lhs->dyn_cast_region_svalue2 ())
-	if (region_svalue2 *rhs_ptr = rhs->dyn_cast_region_svalue2 ())
+      if (const region_svalue2 *lhs_ptr = lhs->dyn_cast_region_svalue2 ())
+	if (const region_svalue2 *rhs_ptr = rhs->dyn_cast_region_svalue2 ())
 	  {
 	    tristate res = region_svalue2::eval_condition (lhs_ptr, op, rhs_ptr);
 	    if (res.is_known ())
@@ -5301,19 +5315,19 @@ region_model2::eval_condition_without_cm (svalue2 *lhs,
 	  }
 
       /* If we have a pair of constants, compare them.  */
-      if (constant_svalue2 *cst_lhs = lhs->dyn_cast_constant_svalue2 ())
-	if (constant_svalue2 *cst_rhs = rhs->dyn_cast_constant_svalue2 ())
+      if (const constant_svalue2 *cst_lhs = lhs->dyn_cast_constant_svalue2 ())
+	if (const constant_svalue2 *cst_rhs = rhs->dyn_cast_constant_svalue2 ())
 	  return constant_svalue2::eval_condition (cst_lhs, op, cst_rhs);
 
       /* Handle comparison of a region_svalue2 against zero.  */
 
-      if (region_svalue2 *ptr = lhs->dyn_cast_region_svalue2 ())
-	if (constant_svalue2 *cst_rhs = rhs->dyn_cast_constant_svalue2 ())
+      if (const region_svalue2 *ptr = lhs->dyn_cast_region_svalue2 ())
+	if (const constant_svalue2 *cst_rhs = rhs->dyn_cast_constant_svalue2 ())
 	  if (zerop (cst_rhs->get_constant ()))
 	    {
 	      /* A region_svalue2 is a non-NULL pointer, except in certain
 		 special cases (see the comment for region2::non_null_p.  */
-	      region2 *pointee = ptr->get_pointee ();
+	      const region2 *pointee = ptr->get_pointee ();
 	      if (pointee->non_null_p (*this))
 		{
 		  switch (op)
@@ -5352,8 +5366,8 @@ region_model2::add_constraint (tree lhs, enum tree_code op, tree rhs,
   if (FLOAT_TYPE_P (TREE_TYPE (lhs)) || FLOAT_TYPE_P (TREE_TYPE (rhs)))
     return true;
 
-  svalue2 *lhs_sval = get_rvalue (lhs, ctxt);
-  svalue2 *rhs_sval = get_rvalue (rhs, ctxt);
+  const svalue2 *lhs_sval = get_rvalue (lhs, ctxt);
+  const svalue2 *rhs_sval = get_rvalue (rhs, ctxt);
 
   tristate t_cond = eval_condition (lhs_sval, op, rhs_sval);
 
@@ -5549,7 +5563,7 @@ region_model2::eval_condition (tree lhs,
    Otherwise, return NULL_TREE.  */
 #if 0
 tree
-region_model2::maybe_get_constant (svalue2 *sval) const
+region_model2::maybe_get_constant (const svalue2 *sval) const
 {
   gcc_assert (!sid.null_p ());
   svalue2 *sval = get_svalue2 (sid);
@@ -5573,7 +5587,7 @@ region_model2::add_new_malloc_region2 ()
 /* Attempt to return a tree that represents SVAL, or return NULL_TREE.  */
 
 tree
-region_model2::get_representative_tree (svalue2 *sval) const
+region_model2::get_representative_tree (const svalue2 *sval) const
 {
   if (sval == NULL)
     return NULL_TREE;
@@ -5581,7 +5595,7 @@ region_model2::get_representative_tree (svalue2 *sval) const
   auto_vec<path_var> pvs;
   m_store.get_representative_path_vars (sval, &pvs);
 
-  if (initial_svalue2 *init_sval = sval->dyn_cast_initial_svalue2 ())
+  if (const initial_svalue2 *init_sval = sval->dyn_cast_initial_svalue2 ())
     {
       const region2 *reg = init_sval->get_region ();
       pvs.safe_push (reg->get_representative_path_var ());
@@ -5606,7 +5620,7 @@ region_model2::get_representative_tree (svalue2 *sval) const
       }
 
   /* Handle string literals and various other pointers.  */
-  svalue2 *sval = get_svalue2 (sid);
+  const svalue2 *sval = get_svalue2 (sid);
   if (region_svalue2 *ptr_sval = sval->dyn_cast_region_svalue2 ())
     {
       region2 *reg = ptr_sval->get_pointee ();
@@ -5698,8 +5712,8 @@ region_model2::get_representative_path_var (region2 *reg) const
     }
 
   /* Handle string literals.  */
-  svalue2 *sval = reg->get_value_direct ();
-  if (svalue2 *sval = get_svalue2 (sid))
+  const svalue2 *sval = reg->get_value_direct ();
+  if (const svalue2 *sval = get_svalue2 (sid))
     if (tree cst = sval->maybe_get_constant ())
       if (TREE_CODE (cst) == STRING_CST)
 	return path_var (cst, 0);
@@ -5711,7 +5725,7 @@ region_model2::get_representative_path_var (region2 *reg) const
    path_var instances for them into *OUT.  */
 #if 0
 void
-region_model2::get_path_vars_for_svalue2 (svalue2 *sval, vec<path_var> *out) const
+region_model2::get_path_vars_for_svalue2 (const svalue2 *sval, vec<path_var> *out) const
 {
   unsigned i;
   region2 *region2;
@@ -5731,7 +5745,7 @@ region_model2::set_to_new_unknown_value (region2 *dst_reg, tree type,
 					region_model2_context *ctxt)
 {
   gcc_assert (!dst_reg.null_p ());
-  svalue2 *new_sval = add_svalue2 (new unknown_svalue2 (type));
+  const svalue2 *new_sval = add_svalue2 (new unknown_svalue2 (type));
   set_value (dst_reg, new_sval, ctxt);
 
   // TODO: presumably purge all child region2s too (but do this in set_value?)
@@ -5852,7 +5866,7 @@ region_model2::update_for_call_superedge (const call_superedge &call_edge,
   /* Build a vec of argument svalue2_id, using the current top
      frame for resolving tree expressions.  */
   const gcall *call_stmt = call_edge.get_call_stmt ();
-  auto_vec<svalue2 *> arg_svals (gimple_call_num_args (call_stmt));
+  auto_vec<const svalue2 *> arg_svals (gimple_call_num_args (call_stmt));
 
   for (unsigned i = 0; i < gimple_call_num_args (call_stmt); i++)
     {
@@ -5871,7 +5885,7 @@ region_model2::update_for_return_superedge (const return_superedge &return_edge,
 					    region_model2_context *ctxt)
 {
   /* Get the region2 for the result of the call, within the caller frame.  */
-  region2 *result_dst_reg = NULL;
+  const region2 *result_dst_reg = NULL;
   const gcall *call_stmt = return_edge.get_call_stmt ();
   tree lhs = gimple_call_lhs (call_stmt);
   if (lhs)
@@ -6039,10 +6053,10 @@ region_model2::on_top_level_param (tree param,
 {
   if (POINTER_TYPE_P (TREE_TYPE (param)))
     {
-      region2 *param_reg = get_lvalue (param, ctxt);
-      svalue2 *init_ptr_sval
+      const region2 *param_reg = get_lvalue (param, ctxt);
+      const svalue2 *init_ptr_sval
 	= m_mgr->get_or_create_initial_value (param_reg);
-      region2 *pointee_reg = m_mgr->get_symbolic_region (init_ptr_sval);
+      const region2 *pointee_reg = m_mgr->get_symbolic_region (init_ptr_sval);
       m_store.on_escape_to_unknown_fncall (m_mgr->get_store2_manager (),
 					   pointee_reg);
     }
@@ -6058,8 +6072,8 @@ region_model2::on_top_level_param (tree param,
 
    Return the new frame_region2.  */
 
-region2 *
-region_model2::push_frame (function *fun, vec<svalue2 *> *arg_svals,
+const region2 *
+region_model2::push_frame (function *fun, vec<const svalue2 *> *arg_svals,
 			   region_model2_context *ctxt)
 {
   m_current_frame = m_mgr->get_frame_region (m_current_frame, fun);
@@ -6076,15 +6090,15 @@ region_model2::push_frame (function *fun, vec<svalue2 *> *arg_svals,
 	     rest of the params as uninitialized.  */
 	  if (idx >= arg_svals->length ())
 	    break;
-	  svalue2 *arg_sval = (*arg_svals)[idx];
-	  region2 *parm_reg = get_lvalue (iter_parm, ctxt);
+	  const svalue2 *arg_sval = (*arg_svals)[idx];
+	  const region2 *parm_reg = get_lvalue (iter_parm, ctxt);
 	  set_value (parm_reg, arg_sval, ctxt);
 
 	  /* Also do it for default SSA name (sharing the same value).  */
 	  tree parm_default_ssa = ssa_default_def (fun, iter_parm);
 	  if (parm_default_ssa)
 	    {
-	      region2 *defssa_reg = get_lvalue (parm_default_ssa, ctxt);
+	      const region2 *defssa_reg = get_lvalue (parm_default_ssa, ctxt);
 	      set_value (defssa_reg, arg_sval, ctxt);
 	    }
 	}
@@ -6116,7 +6130,7 @@ region_model2::push_frame (function *fun, vec<svalue2 *> *arg_svals,
 function *
 region_model2::get_current_function () const
 {
-  frame_region2 *frame = get_current_frame ();
+  const frame_region2 *frame = get_current_frame ();
   gcc_assert (frame);
   return frame->get_function ();
 }
@@ -6125,14 +6139,14 @@ region_model2::get_current_function () const
    see the comment for stack_region2::pop_frame.  */
 
 void
-region_model2::pop_frame (region2 *result_dst_reg,
+region_model2::pop_frame (const region2 *result_dst_reg,
 			  bool purge, purge_stats2 *out,
 			  region_model2_context *ctxt)
 {
   gcc_assert (m_current_frame);
 
   /* Evaluate the result, within the callee frame.  */
-  frame_region2 *frame_reg = m_current_frame;
+  const frame_region2 *frame_reg = m_current_frame;
 #if 0
   svalue2_id_set returned_svals;
 #endif
@@ -6160,7 +6174,7 @@ region_model2::pop_frame (region2 *result_dst_reg,
 	      region2_id rid = region2_id::from_int (i);
 	      if (returned_regs.region2_p (rid))
 		{
-		  svalue2 *sval = model->get_region2 (rid)->get_value_direct ();
+		  const svalue2 *sval = model->get_region2 (rid)->get_value_direct ();
 		  returned_svals.add_svalue2 (sid);
 		}
 	    }
@@ -6191,7 +6205,7 @@ region_model2::pop_frame (region2 *result_dst_reg,
 int
 region_model2::get_stack_depth () const
 {
-  frame_region2 *frame = get_current_frame ();
+  const frame_region2 *frame = get_current_frame ();
   if (frame)
     return frame->get_stack_depth ();
   else
@@ -6200,10 +6214,10 @@ region_model2::get_stack_depth () const
 
 /* FIXME.  */
 
-frame_region2 *
+const frame_region2 *
 region_model2::get_frame_at_index (int index) const
 {
-  frame_region2 *frame = get_current_frame ();
+  const frame_region2 *frame = get_current_frame ();
   if (frame)
     {
       gcc_assert (index >= 0);
@@ -6239,7 +6253,7 @@ region_model2::get_function_at_depth (unsigned depth) const
    at the same region2).  */
 #if 0
 void
-region_model2::replace_svalue2 (svalue2 *sval, svalue2 *new_sval)
+region_model2::replace_svalue2 (const svalue2 *sval, const svalue2 *new_sval)
 {
   gcc_assert (!sid.null_p ());
   int idx = sid.as_int ();
@@ -6260,7 +6274,7 @@ class restrict_to_used_svalue2s : public purge_criteria
 public:
   restrict_to_used_svalue2s (const auto_sbitmap &used) : m_used (used) {}
 
-  bool should_purge_p (svalue2 *sval) const FINAL OVERRIDE
+  bool should_purge_p (const svalue2 *sval) const FINAL OVERRIDE
   {
     gcc_assert (!sid.null_p ());
     return !bitmap_bit_p (m_used, sid.as_int ());
@@ -6322,7 +6336,7 @@ region_model2::purge_unused_svalue2s (purge_stats *stats,
   region2 *r;
   FOR_EACH_VEC_ELT (m_region2s, i, r)
     {
-      svalue2 *sval = r->get_value_direct ();
+      const svalue2 *sval = r->get_value_direct ();
       if (!sid.null_p ())
 	bitmap_set_bit (used, sid.as_int ());
     }
@@ -6337,7 +6351,7 @@ region_model2::purge_unused_svalue2s (purge_stats *stats,
     FOR_EACH_VEC_ELT (m_constraints->m_equiv_classes, i, ec)
       {
 	int j;
-	svalue2 **sid;
+	const svalue2 **sid;
 	FOR_EACH_VEC_ELT (ec->m_vars, j, sid)
 	  {
 	    gcc_assert (!sid->null_p ());
@@ -6355,7 +6369,7 @@ region_model2::purge_unused_svalue2s (purge_stats *stats,
   int after_next_unused_new_sval = m_svalue2s.length ();
   for (unsigned i = 0; i < m_svalue2s.length (); i++)
     {
-      svalue2 *src (svalue2_id::from_int (i));
+      const svalue2 *src (svalue2_id::from_int (i));
       if (bitmap_bit_p (used, i))
 	{
 	  if (logger)
@@ -6400,7 +6414,7 @@ region_model2::purge_unused_svalue2s (purge_stats *stats,
     {
       if (logger)
 	{
-	  svalue2 *victim = svalue2_id::from_int (m_svalue2s.length () - 1);
+	  const svalue2 *victim = svalue2_id::from_int (m_svalue2s.length () - 1);
 	  logger->log ("deleting sv%i (was sv%i)",
 		       victim.as_int (),
 		       map.get_src_for_dst (victim).as_int ());
@@ -6521,7 +6535,7 @@ region_model2::poison_any_pointers_to_bad_region2s (const region2_id_set &
 						  enum poison_kind pkind)
 {
   int i;
-  svalue2 *sval;
+  const svalue2 *sval;
   FOR_EACH_VEC_ELT (m_svalue2s, i, sval)
     if (region_svalue2 *ptr_sval = sval->dyn_cast_region_svalue2 ())
       {
@@ -6652,17 +6666,17 @@ region_model2::convert_byte_offset_to_array_index (tree ptr_type,
 
 region2_id
 region_model2::get_or_create_mem_ref (tree type,
-				     svalue2 *ptr_sval,
-				     svalue2 *offset_sval,
+				     const svalue2 *ptr_sval,
+				     const svalue2 *offset_sval,
 				     region_model2_context *ctxt)
 {
-  svalue2 *ptr_sval = get_svalue2 (ptr_sval);
+  const svalue2 *ptr_sval = get_svalue2 (ptr_sval);
   tree ptr_type = ptr_sval->get_type ();
   gcc_assert (ptr_type);
 
   region2 *raw_reg = deref_rvalue (ptr_sval, ctxt);
 
-  svalue2 *offset_sval = get_svalue2 (offset_sval);
+  const svalue2 *offset_sval = get_svalue2 (offset_sval);
   tree offset_type = offset_sval->get_type ();
   gcc_assert (offset_type);
 
@@ -6693,7 +6707,7 @@ region_model2::get_or_create_mem_ref (tree type,
 						      &key_for_raw_reg))
 	    {
 	      /* Convert from offset to index.  */
-	      svalue2 *index_sval
+	      const svalue2 *index_sval
 		= convert_byte_offset_to_array_index (ptr_type, offset_sval);
 	      if (tree index_cst
 		    = get_svalue2 (index_sval)->maybe_get_constant ())
@@ -6705,7 +6719,7 @@ region_model2::get_or_create_mem_ref (tree type,
 		  tree index_rel_to_parent_cst
 		    = wide_int_to_tree (integer_type_node,
 					index_rel_to_parent);
-		  svalue2 *index_sval
+		  const svalue2 *index_sval
 		    = get_or_create_constant_svalue2 (index_rel_to_parent_cst);
 
 		  /* Carry on, using the parent region2 and adjusted index.  */
